/* RCS $Id: j_acth.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: j_acth.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:26:20  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_intv j_acth(a_intv x)               */
/*                        a_intv x  ;                           */
/*                                                              */
/*      Arguments       : x = interval argument of acth(x)      */
/*                                                              */
/*      Description     : Fast interval area tangens function   */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local a_intv j_acth(a_intv x)
#else
local a_intv j_acth(x)

a_intv x;
#endif
{
 a_intv res;

 if (x.SUP<-1)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_acth(x.INF);
      res.SUP=res.INF*q_actm;
      res.INF*=q_actp;
    }
   else
    {
      res.INF=q_acth(x.SUP)*q_actp;
      res.SUP=q_acth(x.INF)*q_actm;
    } 
 }    
 else if(x.INF>1)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_acth(x.INF);
      res.SUP=res.INF*q_actp;
      res.INF*=q_actm;
    }
   else
    {
      res.INF=q_acth(x.SUP)*q_actm;
      res.SUP=q_acth(x.INF)*q_actp;
    }  
 }
 else   /* invalid argument */
 {
#ifdef PXSCTRAP
      E_SPUSH("j_acth");
#endif
      res=q_abortr2(INV_ARG,&x.INF,&x.SUP,25);
#ifdef PXSCTRAP      
      E_SPOPP("j_acth");
#endif
 }
 return(res);
}

